function s4() {
    return Math.floor((1 + Math.random()) * 0x10000)
               .toString(16)
               .substring(1);
  }

function generateID() {
	// returns a UUID as new ID for diferent values. will be allways a string
	return s4() + s4() + '-' + s4() + '-' + s4() + '-' +
		           s4() + '-' + s4() + s4() + s4();
}

var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "heating-controller.log";
lWarn = new Logger(LOGFILE_NAME);
lInfo = new Logger(LOGFILE_NAME);

function storeParameter(path,value)
{
	Property.setProperty(path, value);
	Property.setFlag(path, 'ARCHIVE', true);
}

var OperationModes = {
		Off : 0,
		Comfort : 1,
		Eco : 2,
		NotUsed : 3,
		Night : 4,
		Holiday : 5,
		Manual : 6,
		nothing : -1
	};

var DefinitionIDs = {
	ModeOff : 0,
	ModeZoneFollower : -2,
	ModeFixedValue : -3,
	AutoNothingSelected : -4,
	AutoSelectionFailed : -5,
	AutoSelectionPossible : -6
};

var defaultFixedValues={
		'Off':0,
		'Comfort' : 100,
		'Economy' : 50,
		'NotUsed' : 0,
		'Night' : 0,
		'Holiday' : 0
};

var defaultTemperatureValues={
		'Off':8,
		'Comfort' : 22,
		'Economy' : 20,
		'NotUsed' : 18,
		'Night' : 17,
		'Holiday' : 16
};

var stateValues = {
	active:1,
	inactive:2
};

function offlineValues () {
	Property.setProperty('controllerDefinitions/1/id',1);
	Property.setProperty('controllerDefinitions/1/controllerMode',1);
	Property.setProperty('controllerDefinitions/1/name','default radiator heating');
	Property.setProperty('controllerDefinitions/1/kp',"5.0");
	Property.setProperty('controllerDefinitions/1/ts',1);
	Property.setProperty('controllerDefinitions/1/kd',0);
	Property.setProperty('controllerDefinitions/1/ti',150);
	Property.setProperty('controllerDefinitions/1/imin',"-13.33");
	Property.setProperty('controllerDefinitions/1/imax',"13.33");
	Property.setProperty('controllerDefinitions/1/ymin',0);
	Property.setProperty('controllerDefinitions/1/ymax',100);
	Property.setProperty('controllerDefinitions/1/antiwindup',1);
	Property.setProperty('controllerDefinitions/1/keepfloorwarm',0);
	Property.setProperty('controllerDefinitions/1/emergency', 75);
	Property.setProperty('controllerDefinitions/2/id',2);
	Property.setProperty('controllerDefinitions/2/controllerMode',1);
	Property.setProperty('controllerDefinitions/2/name','default floor heating');
	Property.setProperty('controllerDefinitions/2/kp',"5.0");
	Property.setProperty('controllerDefinitions/2/ts',1);
	Property.setProperty('controllerDefinitions/2/kd',0);
	Property.setProperty('controllerDefinitions/2/ti',240);
	Property.setProperty('controllerDefinitions/2/imin',"-13.33");
	Property.setProperty('controllerDefinitions/2/imax',"13.33");
	Property.setProperty('controllerDefinitions/2/ymin',0);
	Property.setProperty('controllerDefinitions/2/ymax',100);
	Property.setProperty('controllerDefinitions/2/antiwindup',1);
	Property.setProperty('controllerDefinitions/2/keepfloorwarm',1);
	Property.setProperty('controllerDefinitions/2/emergency', 75);
}

function reactOnAbsent () {
	Property.setProperty('/scripts/heating-controller/systemTriggers/absent/triggers/1/type','zone-scene');
	Property.setProperty('/scripts/heating-controller/systemTriggers/absent/triggers/1/zone',0);
	Property.setProperty('/scripts/heating-controller/systemTriggers/absent/triggers/1/group',0);
	Property.setProperty('/scripts/heating-controller/systemTriggers/absent/triggers/1/scene',72);
	Property.setProperty('/scripts/heating-controller/systemTriggers/absent/triggers/1/dsid',-1);
	Property.setProperty('/scripts/heating-controller/systemTriggers/present/triggers/1/type','zone-scene');
	Property.setProperty('/scripts/heating-controller/systemTriggers/present/triggers/1/zone',0);
	Property.setProperty('/scripts/heating-controller/systemTriggers/present/triggers/1/group',0);
	Property.setProperty('/scripts/heating-controller/systemTriggers/present/triggers/1/scene',71);
	Property.setProperty('/scripts/heating-controller/systemTriggers/present/triggers/1/dsid',-1);
	
	registerTrigger('/scripts/heating-controller/systemTriggers/absent','heating-controller.operation-mode',{'actions':'reactOnAbsent'});
	registerTrigger('/scripts/heating-controller/systemTriggers/present','heating-controller.operation-mode',{'actions':'reactOnPresent'});	
}

function ensureQueueTrigger() {
	registerState('queue-active',false);
	Property.setProperty('/scripts/heating-controller/systemTriggers/queue/triggers/1/type','addon-state-change');
	Property.setProperty('/scripts/heating-controller/systemTriggers/queue/triggers/1/name','queue-active');
	Property.setProperty('/scripts/heating-controller/systemTriggers/queue/triggers/1/state',"inactive");
	Property.setProperty('/scripts/heating-controller/systemTriggers/queue/triggers/1/addon-id','heating-controller');
	registerTrigger('/scripts/heating-controller/systemTriggers/queue','heating-controller.operation-mode',{'actions':'queue-ready'});
}

function insertHolidayTrigger() {
	Property.setProperty('/scripts/heating-controller/systemTriggers/holiday/triggers/1/type','state-change');
	Property.setProperty('/scripts/heating-controller/systemTriggers/holiday/triggers/1/name','holiday');
	Property.setProperty('/scripts/heating-controller/systemTriggers/holiday/triggers/1/state',"on");
	Property.setProperty('/scripts/heating-controller/systemTriggers/holiday/triggers/2/type','state-change');
	Property.setProperty('/scripts/heating-controller/systemTriggers/holiday/triggers/2/name','holiday');
	Property.setProperty('/scripts/heating-controller/systemTriggers/holiday/triggers/2/state',"off");
	registerTrigger('/scripts/heating-controller/systemTriggers/holiday','heating-controller.preheating-time',{'actions':'checkHoliday'});
}

if (raisedEvent.name=='running') {
	Property.load();
	if (Property.getNode('controllerDefinitions')==null)
		offlineValues();
	reactOnAbsent();
	ensureQueueTrigger();
	insertHolidayTrigger();
	if (Property.getNode('generalSettings/valueProtectionTimeFrame')==null) {
		storeParameter('generalSettings/valueProtectionTimeFrame',15*60);
	}
	if (Property.getNode('generalSettings/valveProtectionWeekday ')==null) {
		storeParameter('generalSettings/valveProtectionWeekday ','TH');
	}
	if (Property.getNode('generalSettings/valveProtectionStartTime')==null) {
		storeParameter('generalSettings/valveProtectionStartTime',15*60*60);
	}
	if (Property.getNode('generalSettings/preheatingTime')==null) {
		storeParameter('generalSettings/preheatingTime',6*60*60);
	}
	
	
	new Event('heating-controller.time-profile',{actions:'queueAllEvents'}).raise();
	new Event('heating-controller.operation-mode',{actions:'sync'}).raise();
	new Event('heating-controller.cloud',{actions:'sync'}).raise();
}


